@use chrono_humanize::*;
@use crate::author_page::OwnedCrate;
@use crate::AuthorPage;
@use crate::format_downloads;
@use crate::Urler;
@use kitchen_sink::MaintenanceStatus;

@(crates: &[OwnedCrate], url: &Urler)

<ul class=crates-list>
  @for OwnedCrate{krate:k, dl, ownership:r, total_owners_count, updated_recently, ..} in crates {
    <li>
      <a href="@url.krate(k)">
        <div class=h>
          <h4>
            @if !k.is_hidden() && !k.is_spam() && !k.is_yanked() && k.maintenance() != MaintenanceStatus::Deprecated { @k.short_name() } else { <del>@k.short_name()</del> }
          </h4>
        </div>
        <div class=meta>
          @if !k.is_yanked() && k.maintenance() != MaintenanceStatus::Deprecated && k.category_slugs().iter().any(|s| &**s == "cryptography::cryptocurrencies") {
            <span title="please don't support cryptocurrencies">‼️</span>
          }
          @if *dl > 1000 && !k.is_yanked() {
            <span class=downloads title="@dl recent downloads">@if let Some((num,unit)) = Some(format_downloads(*dl)) {@num<b>@unit</b>}</span>
          }

          @if k.maintenance() == MaintenanceStatus::Deprecated || k.maintenance() == MaintenanceStatus::LookingForMaintainer {
            Unmaintained.
          }
          else if k.maintenance() == MaintenanceStatus::PassivelyMaintained {
            Passively maintained.
          }
          else if k.maintenance() == MaintenanceStatus::AsIs {
            Archived.
          }

          @if r.invited_by_github_id.is_none() {
            @if *total_owners_count > 1 {Founded in} else {Sole owner since}
            @if let Some(d) = r.invited_at {
              @AuthorPage::format_month(&d).
              @if !k.is_yanked() && k.maintenance() != MaintenanceStatus::Deprecated && k.maintenance() != MaintenanceStatus::LookingForMaintainer {
                @if *updated_recently {Updated} else {Last updated} @HumanTime::from(r.latest_release).to_text_en(Accuracy::Rough, Tense::Past).
              }
            }
          } else {
            @if *total_owners_count > 1 {Member} else {Maintainer}
            @if let Some(d) = r.invited_at {
              since @AuthorPage::format_month(&d)
              @if !k.is_yanked() && k.maintenance() != MaintenanceStatus::Deprecated && k.maintenance() != MaintenanceStatus::LookingForMaintainer && k.maintenance() != MaintenanceStatus::PassivelyMaintained {
                (@HumanTime::from(d).to_text_en(Accuracy::Rough, Tense::Present))
              }
            }
          }
        </div>
      </a>
    </li>
  }
</ul>

